---
title: AudioBufferSourceNode
slug: Web/API/AudioBufferSourceNode
tags:
  - API
  - Audio
  - AudioBufferSourceNode
  - Interface
  - Media
  - Reference
  - Web Audio API
---
<p>{{APIRef("Web Audio API")}}</p>

<p><span class="seoSummary">The <strong><code>AudioBufferSourceNode</code></strong><strong> </strong>interface is an {{domxref("AudioScheduledSourceNode")}} which represents an audio source consisting of in-memory audio data, stored in an {{domxref("AudioBuffer")}}. It's especially useful for playing back audio which has particularly stringent timing accuracy requirements, such as for sounds that must match a specific rhythm and can be kept in memory rather than being played from disk or the network.</span> To play sounds which require accurate timing but must be streamed from the network or played from disk, use a {{domxref("AudioWorkletNode")}} to implement its playback.</p>

<p>{{InheritanceDiagram(600, 140)}}</p>

<p>An <code>AudioBufferSourceNode</code> has no inputs and exactly one output, which has the same number of channels as the <code>AudioBuffer</code> indicated by its {{domxref("AudioBufferSourceNode.buffer", "buffer")}} property. If there's no buffer set—that is, if <code>buffer</code> is <code>null</code>—the output contains a single channel of silence (every sample is 0).</p>

<p>An <code>AudioBufferSourceNode</code> can only be played once; after each call to {{domxref("AudioScheduledSourceNode.start", "start()")}}, you have to create a new node if you want to play the same sound again. Fortunately, these nodes are very inexpensive to create, and the actual <code>AudioBuffer</code>s can be reused for multiple plays of the sound. Indeed, you can use these nodes in a "fire and forget" manner: create the node, call <code>start()</code> to begin playing the sound, and don't even bother to hold a reference to it. It will automatically be garbage-collected at an appropriate time, which won't be until sometime after the sound has finished playing.</p>

<p>Multiple calls to {{domxref("AudioBufferSourceNode.stop", "stop()")}} are allowed. The most recent call replaces the previous one, if the <code>AudioBufferSourceNode</code> has not already reached the end of the buffer.</p>

<p><br>
 <img alt="The AudioBufferSourceNode takes the content of an AudioBuffer and m" src="https://mdn.mozillademos.org/files/9717/WebAudioAudioBufferSourceNode.png" style="display: block; height: 193px; margin: 0px auto; width: 365px;"></p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Number of inputs</th>
   <td><code>0</code></td>
  </tr>
  <tr>
   <th scope="row">Number of outputs</th>
   <td><code>1</code></td>
  </tr>
  <tr>
   <th scope="row">Channel count</th>
   <td>defined by the associated {{domxref("AudioBuffer")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("AudioBufferSourceNode.AudioBufferSourceNode", "AudioBufferSourceNode()")}}</dt>
 <dd>Creates and returns a new <code>AudioBufferSourceNode</code> object. An {{domxref("AudioBufferSourceNode")}} can be instantiated using the {{domxref("AudioContext.createBufferSource()")}} method.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, </em><em>{{domxref("AudioScheduledSourceNode")}}</em>.</p>

<dl>
 <dt>{{domxref("AudioBufferSourceNode.buffer")}}</dt>
 <dd>An {{domxref("AudioBuffer")}} that defines the audio asset to be played, or when set to the value <code>null</code>, defines a single channel of silence (in which every sample is 0.0).</dd>
 <dt>{{domxref("AudioBufferSourceNode.detune")}}</dt>
 <dd>Is a <a href="/en-US/docs/DOM/AudioParam#k-rate">k-rate</a> {{domxref("AudioParam")}} representing detuning of playback in <a href="http://en.wikipedia.org/wiki/Cent_%28music%29">cents</a>. This value is compounded with <code>playbackRate</code> to determine the speed at which the sound is played. Its default value is <code>0</code> (meaning no detuning), and its nominal range is -∞ to ∞.</dd>
 <dt>{{domxref("AudioBufferSourceNode.loop")}}</dt>
 <dd>A Boolean attribute indicating if the audio asset must be replayed when the end of the {{domxref("AudioBuffer")}} is reached. Its default value is <code>false</code>.</dd>
 <dt>{{domxref("AudioBufferSourceNode.loopStart")}} {{optional_inline}}</dt>
 <dd>A floating-point value indicating the time, in seconds, at which playback of the {{domxref("AudioBuffer")}} must begin when <code>loop</code> is <code>true</code>. Its default value is <code>0</code> (meaning that at the beginning of each loop, playback begins at the start of the audio buffer).</dd>
 <dt>{{domxref("AudioBufferSourceNode.loopEnd")}} {{optional_inline}}</dt>
 <dd>A floating-point number indicating the time, in seconds, at which playback of the {{domxref("AudioBuffer")}} stops and loops back to the time indicated by <code>loopStart</code>, if <code>loop</code> is <code>true</code>. The default value is <code>0</code>.</dd>
 <dt>{{domxref("AudioBufferSourceNode.playbackRate")}}</dt>
 <dd>An <a href="/en-US/docs/Web/API/AudioParam#a-rate">a-rate</a> {{domxref("AudioParam")}} that defines the speed factor at which the audio asset will be played, where a value of 1.0 is the sound's natural sampling rate. Since no pitch correction is applied on the output, this can be used to change the pitch of the sample. This value is compounded with <code>detune</code> to determine the final playback rate.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<p><em>Inherits event handlers from its parent, </em><em>{{domxref("AudioScheduledSourceNode")}}</em>.</p>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, </em><em>{{domxref("AudioScheduledSourceNode")}}</em>.</p>

<h2 id="Examples">Examples</h2>

<p>In this example, we create a two-second buffer, fill it with white noise, and then play it using an <code>AudioBufferSourceNode</code>. The comments should clearly explain what is going on.</p>

<div class="note">
<p>You can also <a class="external external-icon" href="https://mdn.github.io/webaudio-examples/audio-buffer/">run the code live</a>, or <a class="external external-icon" href="https://github.com/mdn/webaudio-examples/blob/master/audio-buffer/index.html">view the source</a>.</p>
</div>

<pre class="brush: js notranslate">var audioCtx = new (window.AudioContext || window.webkitAudioContext)();

// Create an empty three-second stereo buffer at the sample rate of the AudioContext
var myArrayBuffer = audioCtx.createBuffer(2, audioCtx.sampleRate * 3, audioCtx.sampleRate);

// Fill the buffer with white noise;
//just random values between -1.0 and 1.0
for (var channel = 0; channel &lt; myArrayBuffer.numberOfChannels; channel++) {
  // This gives us the actual ArrayBuffer that contains the data
  var nowBuffering = myArrayBuffer.getChannelData(channel);
  for (var i = 0; i &lt; myArrayBuffer.length; i++) {
    // Math.random() is in [0; 1.0]
    // audio needs to be in [-1.0; 1.0]
    nowBuffering[i] = Math.random() * 2 - 1;
  }
}

// Get an AudioBufferSourceNode.
// This is the AudioNode to use when we want to play an AudioBuffer
var source = audioCtx.createBufferSource();
// set the buffer in the AudioBufferSourceNode
source.buffer = myArrayBuffer;
// connect the AudioBufferSourceNode to the
// destination so we can hear the sound
source.connect(audioCtx.destination);
// start the source playing
source.start();</pre>

<div class="note">
<p>For a <code>decodeAudioData()</code> example, see the {{domxref("AudioContext.decodeAudioData()")}} page.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#AudioBufferSourceNode', 'AudioBufferSourceNode')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioBufferSourceNode")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
</ul>
